; MP3 Player, Main Program, http://www.pjrc.com/tech/mp3
; Copyright (c) 2000, PJRC.COM, LLC

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

; As a specific exception to the GPL, the executable object code built
; from this source code may be combined with hardware configuration data
; files.  A hardware configuration data file is a set of data that is
; transmitted to an intergrated circuit that is not a general purpose
; microprocessor or microcontroller, in order to establish its normal
; operation.  The process of combining the executable ojbect code built
; from the GPL licensed source code with the hardware configuration data
; shall be considered an aggregation of another work not based on the
; Program.  While the GPL does not restrict use of the program, any
; use restriction associated with the hardware configuration data (for
; example, that it only be used with particular hardware) shall apply
; to the combined file which includes a copy of the hardware configuration
; data.

; Contact: paul@pjrc.com


.equ    location, 0x2000        ;where this program will exist


.equ    cout, 0x0030            ;Send Acc to serial port
.equ    cin, 0x0032             ;Get Acc from serial port
.equ    phex, 0x0034            ;Print Hex value of Acc
.equ	phex1, 0x002E
.equ    phex16, 0x0036          ;Print Hex value of DPTR
.equ    pstr, 0x0038            ;Print string pointed to by DPTR,
.equ    upper, 0x0040           ;Convert Acc to uppercase
.equ    pint8u, 0x004D          ;print Acc at an integer, 0 to 255
.equ    pint8, 0x0050           ;print Acc at an integer, -128 to 127
.equ    pint16u, 0x0053         ;print DPTR as an integer, 0 to 65535
.equ    newline, 0x0048         ;print CR/LF (13 and 10)



.equ	call_bank1, 0x0FE0
.equ	xdownload, 0xA040
.equ	sta013_init, 0xA043
.equ	shutdown, 0xA046



;addresses for accessing the ide interface
.equ	ide_data,	0xFF10
.equ	ide_err,	0xFF11
.equ	ide_features,	0xFF11
.equ    ide_sec_cnt,    0xFF12
.equ    ide_sector,     0xFF13
.equ    ide_cyl_lsb,    0xFF14
.equ    ide_cyl_msb,    0xFF15
.equ    ide_head,       0xFF16
.equ    ide_command,    0xFF17
.equ    ide_status,     0xFF17
.equ    ide_control,    0xFF0E
.equ    ide_astatus,    0xFF0F
.equ	sector_buffer,	0xFC00		;buffer is read only

;IDE Command Constants.  These should never change.
.equ    ide_cmd_recal, 0x10
.equ    ide_cmd_read, 0x20
.equ    ide_cmd_write, 0x30
.equ    ide_cmd_init, 0x91
.equ    ide_cmd_id, 0xEC
.equ    ide_cmd_spindown, 0xE0
.equ    ide_cmd_spinup, 0xE1
.equ	ide_cmd_idle, 0xE1
.equ	ide_cmd_sleep, 0xE6
.equ	ide_cmd_set_features, 0xEF


.equ	status, 0x08			;1 byte
.equ	sectors_per_cluster, 0x09	;1 byte
.equ	button_state, 0x0A		;1 byte
.equ	state_quit, 0x0B		;1 byte

.equ	lba, 0x0C			;4 bytes
.equ	size, 0x10			;4 bytes
.equ	partition_first_sector, 0x14	;4 bytes
.equ	partition_size, 0x18		;4 bytes
.equ	first_data_sector, 0x1C		;4 bytes

.equ	flags, 0x21
.equ	dir_position_sector, 0x22	;1 byte, 0 to sectors_per_cluster-1
.equ	dir_position_offset, 0x23	;1 byte, 0 to 15
.equ	dir_position_cluster, 0x24	;4 bytes

.equ	root_dir_cluster, 0x28		;4 bytes
.equ	cluster, 0x2C			;4 bytes

.equ	filename, 0x30			;11 bytes
.equ	attrib, 0x3B			;1 byte

.equ	reserved_sector_count, 0x3C	;2 bytes
.equ	tmp_var, 0x3E			;4 bytes
.equ	state_next, 0x42		;1 byte
.equ	state_prev, 0x43		;1 byte
.equ	state_play, 0x44		;1 byte

.equ	stack, 0x50




.equ	playing_flag, 0x08
.equ	paused_flag, 0x09
.equ	next_flag, 0x0A
.equ	prev_flag, 0x0B
.equ	end_now_flag, 0x0C



.org    location
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'P',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "MP3 Player",0
.org    location+64             ;executable code begins here




begin:
	mov	sp, #stack
	mov	dptr, #mesg_welcome
	lcall	pstr

	clr	a
	mov	flags, a
	mov	state_quit, a
	mov	state_play, a
	mov	state_next, a
	mov	state_prev, a
	acall	read_buttons
	orl	a, 0x10
	mov	button_state, a

	mov	dptr, #mesg_xilinx_cfg
	lcall	pstr
	mov	dptr, #xdownload
	lcall	call_bank1
	jc	error
	mov	dptr, #mesg_ok
	lcall	pstr

	mov	dptr, #mesg_reset_ide
	lcall	pstr
	acall	ide_reset


	mov	dptr, #mesg_sta013_cfg
	lcall	pstr
	mov	dptr, #sta013_init
	lcall	call_bank1
	jc	error
	mov	dptr, #mesg_ok
	lcall	pstr

	mov	dptr, #mesg_ide_init
	lcall	pstr
	acall	ide_init
	lcall	newline
	ajmp	read_mbr

error:
	mov	dptr, #mesg_error
	lcall	pstr
	ajmp	quit


read_mbr:
	mov	lba+3, #0
	mov	lba+2, #0
	mov	lba+1, #0
	mov	lba+0, #0

	mov	dptr, #mesg_read_mbr
	lcall	pstr
	acall	ide_read_sector
	acall	ide_drq
	acall	grab_data
	mov	dptr, #sector_buffer + 0x1FE
	movx	a, @dptr
	cjne	a, #0x55, bad_mbr
	inc	dptr
	movx	a, @dptr
	cjne	a, #0xAA, bad_mbr

	mov	dptr, #sector_buffer + 0x1C2
	movx	a, @dptr
	acall	is_fat32_type
	jnc	found_partition
	acall	print_unknown_type

	mov	dptr, #sector_buffer + 0x1D2
	movx	a, @dptr
	acall	is_fat32_type
	jnc	found_partition
	acall	print_unknown_type

	mov	dptr, #sector_buffer + 0x1E2
	movx	a, @dptr
	acall	is_fat32_type
	jnc	found_partition
	acall	print_unknown_type

	mov	dptr, #sector_buffer + 0x1F2
	movx	a, @dptr
	acall	is_fat32_type
	jnc	found_partition
	acall	print_unknown_type
	ajmp	quit


is_fat32_type:
	add	a, #256 - 11		;is it type 0B
	jz	isf32b
	add	a, #255			;is it type 0C
	jz	isf32b
	add	a, #12
	setb	c
	ret
isf32b:
	clr	c
	ret




bad_mbr:
	acall	print_sector_buffer
	lcall	newline
	mov	dptr, #mesg_bad_mbr
	lcall	pstr
	ajmp	quit

print_unknown_type:
	push	acc
	mov	dptr, #msg_unknown_partion_type
	lcall	pstr
	pop	acc
	lcall	phex
	lcall	newline
	ret

get_byte:
	movx	a, @dptr
	inc	dptr
	ret
	
found_partition:
	inc	dptr
	inc	dptr
	inc	dptr
	inc	dptr
	acall	get_byte
	mov	partition_first_sector+0, a
	acall	get_byte
	mov	partition_first_sector+1, a
	acall	get_byte
	mov	partition_first_sector+2, a
	acall	get_byte
	mov	partition_first_sector+3, a
	acall	get_byte
	mov	partition_size+0, a
	acall	get_byte
	mov	partition_size+1, a
	acall	get_byte
	mov	partition_size+2, a
	acall	get_byte
	mov	partition_size+3, a

	mov	dptr, #mesg_partition_at
	lcall	pstr
	mov	r0, #partition_first_sector
	acall	phex32_at_r0

	lcall	newline
	ajmp	read_vol_id



bad_vol_id:
	acall	print_sector_buffer
	mov	dptr, #mesg_bad_vol_id
	lcall	pstr
	acall	print_sector_buffer
	ajmp	quit



read_vol_id:

	mov	dptr, #mesg_read_vol_id
	lcall	pstr

	mov	lba+0, partition_first_sector+0
	mov	lba+1, partition_first_sector+1
	mov	lba+2, partition_first_sector+2
	mov	lba+3, partition_first_sector+3
	
	acall	ide_read_sector
	acall	ide_drq
	acall	grab_data

	;acall	print_sector_buffer

	mov	dptr, #sector_buffer + 0x1FE
	movx	a, @dptr
	cjne	a, #0x55, bad_vol_id
	inc	dptr
	movx	a, @dptr
	cjne	a, #0xAA, bad_vol_id
	mov	dptr, #sector_buffer + 11
	movx    a, @dptr
	jnz	bad_vol_id			;require 512 byte sector
	inc	dptr
	movx    a, @dptr
	cjne	a, #2, bad_vol_id		;require 512 byte sector
	mov	dptr, #sector_buffer + 16
	movx    a, @dptr
	cjne	a, #2, bad_vol_id		;require BPB_NumFATs == 2

	mov	dptr, #mesg_vol_id_ok
	lcall	pstr

	clr	c
	mov	dptr, #sector_buffer + 36	;offset of BPB_FATSz32
	movx	a, @dptr
	rlc	a
	mov	r2, a				;r2 to r5 has BPB_FATSz32 * 2
	inc	dptr
	movx	a, @dptr
	rlc	a
	mov	r3, a
	inc	dptr
	movx	a, @dptr
	rlc	a
	mov	r4, a
	inc	dptr
	movx	a, @dptr
	rlc	a
	mov	r5, a

	mov	dptr, #mesg_sectors_for_fats
	lcall	pstr
	mov	r0, #2
	acall	phex32_at_r0
	lcall	newline

	mov	dptr, #sector_buffer + 14	;read BPB_RsvdSecCnt
	movx	a, @dptr
	mov	reserved_sector_count+0, a
	inc	dptr
	movx	a, @dptr
	mov	reserved_sector_count+1, a

	mov	dptr, #mesg_reserved_sectors
	lcall	pstr
	mov	a, reserved_sector_count+1
	lcall	phex
	mov	a, reserved_sector_count+0
	lcall	phex
	lcall	newline

	mov	a, r2				;add (BPB_FATSz32 * 2)
	add	a, reserved_sector_count+0	;to reserved_sector_count
	mov	first_data_sector+0, a		;and store as first_data_sector
	mov	a, r3
	addc	a, reserved_sector_count+1
	mov	first_data_sector+1, a
	mov	a, r4
	addc	a, #0
	mov	first_data_sector+2, a
	mov	a, r5
	addc	a, #0
	mov	first_data_sector+3, a

	mov	a, first_data_sector+0
	add	a, partition_first_sector+0
	mov	first_data_sector+0, a
	mov	a, first_data_sector+1
	addc	a, partition_first_sector+1
	mov	first_data_sector+1, a
	mov	a, first_data_sector+2
	addc	a, partition_first_sector+2
	mov	first_data_sector+2, a
	mov	a, first_data_sector+3
	addc	a, partition_first_sector+3
	mov	first_data_sector+3, a

	mov	dptr, #mesg_first_data_sec
	lcall	pstr
	mov	r0, #first_data_sector
	acall	phex32_at_r0
	lcall	newline

	mov	dptr, #sector_buffer + 13	;read BPB_SecPerClus
	movx	a, @dptr
	mov	sectors_per_cluster, a

	mov	dptr, #mesg_sec_per_cluster
	lcall	pstr
	mov	a, sectors_per_cluster
	lcall	phex
	lcall	newline

	mov	dptr, #sector_buffer + 44	;read BPB_RootClus
	movx	a, @dptr
	mov	root_dir_cluster+0, a
	inc	dptr
	movx	a, @dptr
	mov	root_dir_cluster+1, a
	inc	dptr
	movx	a, @dptr
	mov	root_dir_cluster+2, a
	inc	dptr
	movx	a, @dptr
	mov	root_dir_cluster+3, a

	mov	dptr, #mesg_root_dir_at_cluster
	lcall	pstr
	mov	r0, #root_dir_cluster
	acall	phex32_at_r0
	lcall	newline

	ajmp	begin_player





;*************************************************************
;**                                                         **
;**                  MP3 Player Main Code                   **
;**                                                         **
;*************************************************************

begin_player:
	mov	dptr, #mesg_begin
	lcall	pstr
	clr	next_flag
	clr	prev_flag
	clr	paused_flag

	; begin with the first file in the root directory
	mov	dir_position_cluster+0, root_dir_cluster+0
	mov	dir_position_cluster+1, root_dir_cluster+1
	mov	dir_position_cluster+2, root_dir_cluster+2
	mov	dir_position_cluster+3, root_dir_cluster+3
	mov	dir_position_sector, #0
	mov	dir_position_offset, #0

traverse_dir:
	acall	fat32_get_dir_info
        mov	a, filename
	jz	stop_playing
	;acall	print_filename
	acall	is_mp3_file
	jnc	trav_dir2
	acall	play_file
trav_dir2:
	acall	trav_direction
	jnc	traverse_dir

stop_playing:
	;now what do we do?
	;let's just start over again for now
	ajmp	begin_player


trav_direction:
	jb	prev_flag, trav_prev
trav_next:
	ajmp	fat32_next_file
trav_prev:
	ajmp	fat32_prev_file






;*************************************************************
;**                                                         **
;**                       Play a File                       **
;**                                                         **
;*************************************************************


play_file:
					;print a message about the file
	mov	dptr, #mesg_playing_file
	lcall	pstr
	acall	print_filename

	clr	next_flag
	clr	prev_flag
	clr	paused_flag
					;find the first sector
	mov	r2, cluster+0
	mov	r3, cluster+1
	mov	r4, cluster+2
	mov	r5, cluster+3
	acall	fat32_cluster_to_lba

	acall	bytes_to_sectors

	;mov	size+2, #0		;for testing, only play first
	;mov	size+1, #0		;64k of the file
	;mov	size+0, #128

	;now "lba" has the first sector number and "size" has the
	;number of sectors to play.  In an ideal world, we'd play
	;all the sectors within this cluster and call
	;"fat32_next_cluster" to get the next cluster's "lba", and
	;keep doing that until we've played "size" sectors.
	
	;unfortunately, we can't afford to call "fat32_next_cluster"
	;while we're playing a file, because it reads a sector and
	;that will take too much time, because we have only one
	;sector of buffering without the DRAM.

	;the approach is to just assume that all the clusters for
	;the file are in sequential order.  This means the user
	;must run defrag.  Kinda sad, because if we could buffer
	;a cluster or two (or 32 megs!) there'd be plenty of time
	;to call "fat32_next_cluster", which would also work with
	;buffered sectors in most cases.  I gotta get that DRAM
	;controller integrated into the FPGA design!


	acall	ide_read_sector
	acall	inc_lba

mainloop:
	acall	ide_drq
	acall	grab_data

	mov	dptr, #0xFF31
	movx	@dptr, a		;clear the address counter

	mov	dptr, #0xFF37
	movx	@dptr, a		;clear interrupt bit

	mov	dptr, #0xFF33
	movx	@dptr, a		;begin data xfer

	acall	dec_size
	jc	main_exit
	jb	next_flag, main_exit
	jb	prev_flag, main_exit
	jb	paused_flag, pause_loop

main_reenter:
	clr	paused_flag

	acall	ide_read_sector
	acall	inc_lba
	acall	check_buttons

mainwait:
	mov	status, #8
	acall	wait
	jb	p3.2, mainwait
	mov	status, #9
	mov	dptr, #0xFF37
	movx	@dptr, a		;ack the interrupt bit
	sjmp	mainloop

main_exit:
	mov	status, #10
	acall	wait
	jb	p3.2, main_exit
	mov	status, #11
	mov	dptr, #0xFF37
	movx	@dptr, a		;ack the interrupt bit
	lcall	newline
	ret


pause_loop:
	clr	playing_flag
	setb	paused_flag
	acall	check_buttons

	jb	next_flag, main_reenter
	jb	playing_flag, main_reenter
	jnb	paused_flag, main_reenter

	acall	wait
	sjmp	pause_loop


inc_lba:
	mov	a, lba
	add	a, #1
	mov	lba, a
	mov	a, lba+1
	addc	a, #0
	mov	lba+1, a
	mov	a, lba+2
	addc	a, #0
	mov	lba+2, a
	mov	a, lba+3
	addc	a, #0
	mov	lba+3, a
	ret

	;decrement the size count, and return C=1 if zero
dec_size:
	clr	c
	mov	a, size+0
	subb	a, #1
	mov	size+0, a
	mov	a, size+1
	subb	a, #0
	mov	size+1, a
	mov	a, size+2
	subb	a, #0
	mov	size+2, a
	jnz	dec_size2
	mov	a, size+0
	jnz	dec_size2
	mov	a, size+1
	jnz	dec_size2
	setb	c
	ret
dec_size2:
	clr	c
	ret




wait:
	jb	ri, keypress
	ret

keypress:
	lcall	cin
	lcall	upper
	lcall	cout
	mov	r2, a

check_quit:
	mov	dptr, #str_quit
	mov	r0, #state_quit
	acall	lexer
	jnc	check_next
	ajmp	quit
	ret

check_next:
	mov	dptr, #str_next
	mov	r0, #state_next
	acall	lexer
	jnc	check_prev
	acall	button_next
	ret

check_prev:
	mov	dptr, #str_previous
	mov	r0, #state_prev
	acall	lexer
	jnc	check_play
	acall	button_prev
	ret

check_play:
	mov	dptr, #str_play
	mov	r0, #state_play
	acall	lexer
	jnc	check_all_done
	acall	button_play
	ret

check_all_done:
	ret


quit:
	acall	ide_sleep
	lcall	newline
	mov	a, status
	lcall	phex
	lcall	newline
	ljmp	0x006D			;go back to PM2



;A simple fixed-string lexer.  For each character received from an
;input stream, this routine is called once for every string which
;is to be recognized within the input stream.

;  Input registers:
;    r0    Memory location to the index variable for this
;          particular string.
;    r2    The character we received.
;    dptr  Pointer to the string pattern we want to match.

;  Output registers:
;    c     Carry set if complete string found, clear if no match yet.
;    mem   Value @r0 adjusted appropriately for the next call.

lexer:
        mov     a, @r0
        inc     a               ;don't look at length byte
        movc    a, @a+dptr      ;get character from string 
        clr     c
        subb    a, r2
        jnz     lex_nope
           ;at this point, it matches the string, so now
           ;the question becomes "are we at the end?"
        inc     @r0             ;advance index
        clr     a
        movc    a, @a+dptr      ;get string length
        clr     c
        subb    a, @r0          ;subtract index
        jz      lex_match
           ;we're not at the end of the string yet
        clr     c
        ret
lex_match: ;we've found all of the string now
        mov     @r0, a          ;reset index automatically
        setb    c
        ret
lex_nope:  ;the received character doesn't match the string
           ;so we set the index back to zero, and return with
           ;carry clear
        mov     @r0, #0
        clr     c
        ret








.equ    hc165_load_pin, 0x94
.equ    hc165_clk_pin, 0x95
.equ    hc165_data_pin, 0x96



read_buttons:
	clr	hc165_load_pin
	nop
	setb	hc165_load_pin
	mov	a, #255
	mov	c, hc165_data_pin
	clr	hc165_clk_pin
	rlc	a
	setb	hc165_clk_pin
	mov	c, hc165_data_pin
	clr	hc165_clk_pin
	rlc	a
	setb	hc165_clk_pin
	mov	c, hc165_data_pin
	clr	hc165_clk_pin
	rlc	a
	setb	hc165_clk_pin
	mov	c, hc165_data_pin
	clr	hc165_clk_pin
	rlc	a
	setb	hc165_clk_pin
	mov	c, hc165_data_pin
	clr	hc165_clk_pin
	rlc	a
	setb	hc165_clk_pin
	mov	c, hc165_data_pin
	rlc	a
	cpl	a
	ret


;button 1: 02	forward
;button 2: 10	play
;button 3: 20	previous
;button 4: 08	random
;button 5: 01	vol_plus
;button 6: 04	vol_minus

check_buttons:
	acall	read_buttons
	cjne	a, button_state, ckb2
	ret
ckb2:
	mov	b, button_state
	mov	button_state, a
	jnb	acc.4, ckb3
	jnb	b.4, button_play
ckb3:
	jnb	acc.1, ckb4
	jnb	b.1, button_next
ckb4:
	jnb	acc.5, ckb5
	jnb	b.5, button_prev
ckb5:
	jnb	acc.3, ckb6
	jnb	b.3, button_rand
ckb6:
	jnb	acc.0, ckb7
	jnb	b.0, button_vol_up
ckb7:
	jnb	acc.2, ckb8
	jnb	b.2, button_vol_down
ckb8:
	ret



button_play:
	jb	playing_flag, button_pause
	mov	dptr, #mesg_play
	lcall	pstr
	setb	playing_flag
	clr	paused_flag
	ret

button_pause:
	mov	dptr, #mesg_pause
	lcall	pstr
	setb	paused_flag
	clr	playing_flag
	ret

button_next:
	mov	dptr, #mesg_next
	lcall	pstr
	setb	next_flag
	ret

button_prev:
	mov	dptr, #mesg_prev
	lcall	pstr
	setb	prev_flag
	ret

button_rand:
	mov	dptr, #mesg_rand
	lcall	pstr
	ret

button_vol_up:
	mov	dptr, #mesg_vol_up
	lcall	pstr
	ret

button_vol_down:
	mov	dptr, #mesg_vol_down
	lcall	pstr
	ret









space:
	mov	a, #' '
	ljmp	cout


	;print a 32 bit number stored @r0
phex32_at_r0:
	inc	r0
	inc	r0
	inc	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	ret





;*************************************************************
;**                                                         **
;**                    FAT32 Filesystem                     **
;**                                                         **
;*************************************************************


	;lookup the next cluster of a file, given the current
	;cluster in r2 to r5.  The next cluser is returned
	;in r2 to r5.

fat32_next_cluster:

	;mov	r0, #2
	;acall	phex32_at_r0
	;mov	a, #'-'
	;lcall	cout

	mov	a, r2
	push	acc		;keep the lowest byte on the stack
	rlc	a
	mov	a, r3		;rotate bits 8 to 31 into r2 to r5
	rlc	a
	mov	r2, a
	mov	a, r4
	rlc	a
	mov	r3, a
	mov	a, r5
	anl	a, #15
	rlc	a
	mov	r4, a
	clr	a
	rlc	a
	mov	r5, a

	;mov	r0, #2
	;acall	phex32_at_r0
	;mov	a, #'-'
	;lcall	cout

				;add reserved_sector_count
	mov	a, r2
	add	a, reserved_sector_count+0
	mov	r2, a
	mov	a, r3
	addc	a, reserved_sector_count+1
	mov	r3, a
	mov	a, r4
	addc	a, #0
	mov	r4, a
	mov	a, r5
	addc	a, #0
	mov	r5, a

	;mov	r0, #2
	;acall	phex32_at_r0
	;mov	a, #'-'
	;lcall	cout
				;add partition_first_sector
	mov	a, r2
	add	a, partition_first_sector+0
	mov	r2, a
	mov	a, r3
	addc	a, partition_first_sector+1
	mov	r3, a
	mov	a, r4
	addc	a, partition_first_sector+2
	mov	r4, a
	mov	a, r5
	addc	a, partition_first_sector+3
	mov	r5, a
				;now r2 to r5 points to sector of the FAT
	mov	lba+0, r2
	mov	lba+1, r3
	mov	lba+2, r4
	mov	lba+3, r5

	;mov	r0, #2
	;acall	phex32_at_r0
	;mov	a, #'-'
	;lcall	cout
					;read the sector from the FAT
	acall	ide_read_sector
	acall	ide_drq
	acall	grab_data

	;acall	print_sector_buffer

	pop	acc			;retrieve low byte
	anl	a, #0x7F		;only need the low 7 bits
	clr	c
	rlc	a			;mult by 4 for offset in sector
	rlc	a
	mov	r2, a
	clr	a
	rlc	a
	mov	r3, a
					;add the offset to the buffer addr
	mov	a, #sector_buffer & 255
	add	a, r2
	mov	dpl, a
	mov	a, #sector_buffer >> 8
	addc	a, r3
	mov	dph, a

	movx	a, @dptr
	mov	r2, a
	inc	dptr
	movx	a, @dptr
	mov	r3, a
	inc	dptr
	movx	a, @dptr
	mov	r4, a
	inc	dptr
	movx	a, @dptr
	anl	a, #15
	mov	r5, a

	;mov	r0, #2
	;acall	phex32_at_r0
	;lcall	newline

	ret


	;convert a cluster number in r2 to r5 to a LBA address
	;and put it into LBA.

fat32_cluster_to_lba:
	clr	c
	mov	a, r2		;first, subtract 2
	subb	a, #2
	mov	lba+0, a
	mov	a, r3
	subb	a, #0
	mov	lba+1, a
	mov	a, r4
	subb	a, #0
	mov	lba+2, a
	mov	a, r5
	anl	a, #15
	subb	a, #0
	mov	lba+3, a
				;now multiply by sectors_per_cluster
				;always power of two, so use shifts
	mov	r0, sectors_per_cluster
f32_c2l_1:
	mov	a, r0
	clr	c
	rrc	a
	mov	r0, a
	jz	f32_c2l_2
	clr	c
	mov	a, lba+0
	rlc	a
	mov	lba+0, a
	mov	a, lba+1
	rlc	a
	mov	lba+1, a
	mov	a, lba+2
	rlc	a
	mov	lba+2, a
	mov	a, lba+3
	rlc	a
	mov	lba+3, a
	sjmp	f32_c2l_1
f32_c2l_2:
	mov	a, lba+0
	add	a, first_data_sector+0
	mov	lba+0, a
	mov	a, lba+1
	addc	a, first_data_sector+1
	mov	lba+1, a
	mov	a, lba+2
	addc	a, first_data_sector+2
	mov	lba+2, a
	mov	a, lba+3
	addc	a, first_data_sector+3
	mov	lba+3, a
	ret



	;return C=0 if r2 to r5 contain an EOC marker, or C=1
	;if they do not.

fat32_is_eoc:
	clr	c
	mov	a, r2
	subb	a, #0xF8
	mov	a, r3
	subb	a, #0xFF
	mov	a, r4
	subb	a, #0xFF
	mov	a, r5
	anl	a, #15
	subb	a, #0x0F
	ret



	;advance the "dir_position_XXX" variables to the next file
	;Carry is set if end of directory, clear if not at the end

fat32_next_file:
	;more forward one position within the current sector
	mov	a, dir_position_offset
	inc	a
	anl	a, #15
	mov	dir_position_offset, a
	jnz	f32_nf_done

	;move to the next sector within the cluster
	mov	r2, sectors_per_cluster
	dec	r2
	mov	a, dir_position_sector
	inc	a
	anl	a, r2
	mov	dir_position_sector, a
	jnz	f32_nf_done

	;move to the next cluster
	mov	r2, dir_position_cluster+0
	mov	r3, dir_position_cluster+1
	mov	r4, dir_position_cluster+2
	mov	r5, dir_position_cluster+3

	acall	fat32_next_cluster

	acall	fat32_is_eoc
	jnc	f32_nf_end
	mov	dir_position_cluster+0, r2
	mov	dir_position_cluster+1, r3
	mov	dir_position_cluster+2, r4
	mov	dir_position_cluster+3, r5
f32_nf_done:
	clr	c
	ret

f32_nf_end:
	mov	dir_position_cluster+0, root_dir_cluster+0
	mov	dir_position_cluster+1, root_dir_cluster+1
	mov	dir_position_cluster+2, root_dir_cluster+2
	mov	dir_position_cluster+3, root_dir_cluster+3
	setb	c
	ret





	;back up the "dir_position_XXX" variables to the previous file
	;Carry is set if beginning of directory, clear if not at the beginning

fat32_prev_file:
	;back up one position within the current sector
	mov	a, dir_position_offset
	dec	a
	anl	a, #15
	mov	dir_position_offset, a
	orl	a, #0xF0
	cpl	a
	jnz	f32_pf_done

	;back up one sector within the current cluster
	mov	r2, sectors_per_cluster
	dec	r2
	mov	a, r2
	cpl	a
	mov	r3, a
	mov	a, dir_position_sector
	dec	a
	anl	a, r2
	mov	dir_position_sector, a
	orl	a, r3
	cpl	a
	jz	f32_pf_prev_cluster
f32_pf_done:
	clr	c
	ret



f32_pf_prev_cluster:
	;now for the really hard part... find the previous cluster!
	;FAT32 doesn't have any easy way to figure out the previous
	;cluster, and since we don't remember it (someday when the
	;DRAM controller is supported we will), the only choice is
	;to follow the cluster chain from the beginning until we get
	;to the current spot, and see what the previous cluster was.

	;"tmp_var" will remember the previous cluster, and we init
	;it with the EOC marker, in case there is no previous cluster
	mov	tmp_var+0, 0xFF
	mov	tmp_var+1, 0xFF
	mov	tmp_var+2, 0xFF
	mov	tmp_var+3, 0x0F
	mov	r2, root_dir_cluster+0
	mov	r3, root_dir_cluster+1
	mov	r4, root_dir_cluster+2
	mov	r5, root_dir_cluster+3

f32_pf_loop:
	;mov	r0, #tmp_var
	;acall	phex32_at_r0
	;acall	space
	;mov	r0, #dir_position_cluster
	;acall	phex32_at_r0
	;acall	space
	;mov	r0, #2
	;acall	phex32_at_r0
	;lcall	newline

	;if r2/r5 match "dir_position_cluster", then we're done searching
	mov	a, r2
	cjne	a, dir_position_cluster+0, f32_pf_nxt
	mov	a, r3
	cjne	a, dir_position_cluster+1, f32_pf_nxt
	mov	a, r4
	cjne	a, dir_position_cluster+2, f32_pf_nxt
	mov	a, r5
	cjne	a, dir_position_cluster+3, f32_pf_nxt
	sjmp	f32_pf_cluster
f32_pf_nxt:
	mov	tmp_var+0, r2
	mov	tmp_var+1, r3
	mov	tmp_var+2, r4
	mov	tmp_var+3, r5

	acall	fat32_next_cluster

	acall	fat32_is_eoc		;should never hit the end!
	jnc	f32_pf_error
	sjmp	f32_pf_loop


f32_pf_cluster:
	;at this point, "tmp_var" has the previous cluster.  All
	;we need to do is make sure it really is a valid cluster.
	mov	r2, tmp_var+0
	mov	r3, tmp_var+1
	mov	r4, tmp_var+2
	mov	r5, tmp_var+3
	acall	fat32_is_eoc
	jnc	f32_pf_end

	mov	dir_position_cluster+0, tmp_var+0
	mov	dir_position_cluster+1, tmp_var+1
	mov	dir_position_cluster+2, tmp_var+2
	mov	dir_position_cluster+3, tmp_var+3
	sjmp	f32_pf_done


f32_pf_error:
f32_pf_end:
	mov	dir_position_cluster+0, root_dir_cluster+0
	mov	dir_position_cluster+1, root_dir_cluster+1
	mov	dir_position_cluster+2, root_dir_cluster+2
	mov	dir_position_cluster+3, root_dir_cluster+3
	mov	dir_position_sector, #0
	mov	dir_position_offset, #0
	setb	c
	ret

















	;get the 32 bytes of info about the current file.
	;the 32 bytes are always returned at the beginning
	;of the sector buffer.

fat32_get_dir_info:
					;find the first sector of cluster
	mov	r2, dir_position_cluster+0
	mov	r3, dir_position_cluster+1
	mov	r4, dir_position_cluster+2
	mov	r5, dir_position_cluster+3
	acall	fat32_cluster_to_lba
					;add the sector offset with cluster
	mov	a, lba+0
	add	a, dir_position_sector
	mov	lba+0, a
	mov	a, lba+1
	addc	a, #0
	mov	lba+1, a
	mov	a, lba+2
	addc	a, #0
	mov	lba+2, a
	mov	a, lba+3
	addc	a, #0
	mov	lba+3, a
					;read the sector
	acall	ide_read_sector
	acall	ide_drq
	acall	grab_data
					;set DPTR to point to dir entry
	mov	a, dir_position_offset
	anl	a, #15
	swap	a
	clr	c
	rlc	a			;mult by 32
	mov	r2, a
	clr	a
	rlc	a
	mov	r3, a
	mov	a, #sector_buffer & 255
	add	a, r2
	mov	dpl, a
	mov	a, #sector_buffer >> 8
	addc	a, r3
	mov	dph, a
					;copy the filename
	mov	r0, #filename
f32_gdi2:
	movx	a, @dptr
	inc	dptr
	mov	@r0, a
	inc	r0
	cjne	r0, #filename+11, f32_gdi2
					;copy the attrib
	movx	a, @dptr
	mov	attrib, a
					;copy first cluster number
	mov	a, dpl
	add	a, #9
	mov	dpl, a
	mov	a, dph
	addc	a, #0
	mov	dph, a
	movx	a, @dptr
	inc	dptr
	mov	cluster+2, a
	movx	a, @dptr
	inc	dptr
	mov	cluster+3, a
	inc	dptr			;skip write time and date
	inc	dptr
	inc	dptr
	inc	dptr
	movx	a, @dptr
	inc	dptr
	mov	cluster+0, a
	movx	a, @dptr
	inc	dptr
	mov	cluster+1, a
					;copy file size
	movx	a, @dptr
	inc	dptr
	mov	size+0, a
	movx	a, @dptr
	inc	dptr
	mov	size+1, a
	movx	a, @dptr
	inc	dptr
	mov	size+2, a
	movx	a, @dptr
	inc	dptr
	mov	size+3, a
	ret




	;return C=1 if it's a MP3 file, or C=0 if not
is_mp3_file:
	mov	a, filename+0
	jz	isfile_no
	add	a, #256 - 0xE5
	jz	isfile_no
	mov	a, attrib
	jb	acc.1, isfile_no	;ATTR_HIDDEN
	jb	acc.2, isfile_no	;ATTR_SYSTEM
	jb	acc.3, isfile_no	;ATTR_VOLUME_ID
	jb	acc.4, isfile_no	;ATTR_DIRECTORY
	mov	a, filename+8
	cjne	a, #'M', isfile_no
	mov	a, filename+9
	cjne	a, #'P', isfile_no
	mov	a, filename+10
	cjne	a, #'3', isfile_no
	setb	c
	ret
isfile_no:
	clr	c
	ret


	;print the filename, attrib, first cluster, and file size

print_filename:
	mov	r0, #filename
pfn1:
	mov	a, @r0
	lcall	cout
	inc	r0
	cjne	r0, #filename+8, pfn1
	mov	a, #'.'
	lcall	cout
pfn2:
	mov	a, @r0
	lcall	cout
	inc	r0
	cjne	r0, #filename+11, pfn2

	mov	dptr, #mesg_attrib
	lcall	pstr
	mov	a, attrib
	lcall	phex
	mov	dptr, #mesg_cluster
	lcall	pstr
	mov	r0, #cluster
	acall	phex32_at_r0
	mov	dptr, #mesg_size
	lcall	pstr
	mov	r0, #size
	acall	phex32_at_r0
	lcall	newline

	mov	r0, #dir_position_cluster
	acall	phex32_at_r0
	acall	space
	mov	a, dir_position_sector
	lcall	phex
	acall	space
	mov	a, dir_position_offset
	lcall	phex
	lcall	newline

	ret


	;convert "size" in bytes to the number of sectors.  It's
	;just a divide by 512 with rounding up

bytes_to_sectors:
	mov	r2, size+0	;save lower 9 bits
	mov	a, size+1
	anl	a, #1
	mov	r3, a

	clr	c		;rotate right 1 bit
	mov	a, size+3
	rrc	a
	mov	size+3, a
	mov	a, size+2
	rrc	a
	mov	size+2, a
	mov	a, size+1
	rrc	a
	mov	size+1, a
	mov	size+0, size+1	;rotate another 8 bits
	mov	size+1, size+2
	mov	size+2, size+3
	mov	size+3, #0
	mov	a, r2
	jnz	b2s_inc
	mov	a, r3
	jnz	b2s_inc
	ret
b2s_inc:			;round up
	mov	a, size+0
	add	a, #1
	mov	size+0, a
	mov	a, size+1
	addc	a, #0
	mov	size+1, a
	mov	a, size+2
	addc	a, #0
	mov	size+2, a
	ret










;*************************************************************
;**                                                         **
;**              IDE Disk Drive Driver Code                 **
;**                                                         **
;*************************************************************




ide_read_sector:
	acall	ide_busy
	mov	dptr, #ide_head
	mov	a, lba+3
	anl	a, #0x0F
	orl	a, #0xE0
	movx	@dptr, a
	mov	dptr, #ide_cyl_msb
	mov	a, lba+2
	movx	@dptr, a
	mov	dptr, #ide_cyl_lsb
	mov	a, lba+1
	movx	@dptr, a
	mov	dptr, #ide_sector
	mov	a, lba+0
	movx	@dptr, a
	mov	dptr, #ide_sec_cnt
	mov	a, #1
	movx	@dptr, a
	mov	dptr, #ide_command
	mov	a, #ide_cmd_read
	movx	@dptr, a
	ret


	;ask the drive to run in it's lowest current mode
	;does this work?  Need to fiddle with it some more.

ide_set_low_power:
	;acall	ide_drq
	mov	dptr, #ide_features
	mov	a, #0x9A		;set current subcommand
	movx	@dptr, a
	mov	dptr, #ide_sec_cnt
	mov	a, #1			;lowest available current
	movx	@dptr, a
	mov	dptr, #ide_command
	mov	a, #ide_cmd_set_features
	movx	@dptr, a
	ret

	;put the drive into sleep mode

ide_sleep:
	; acall	ide_busy
	mov	dptr, #ide_command
	mov	a, #ide_cmd_sleep
	movx	@dptr, a
	;acall	ide_busy
	mov	dptr, #ide_status
	movx	a, @dptr
	ret




ide_reset:
	mov	dptr, #0xFF32
	mov	a, #255
	movx	@dptr, a		;assert drive's reset pin
	mov	r0, #0
	djnz	r0, *
	djnz	r0, *
	djnz	r0, *
	mov	a, #0
	movx	@dptr, a		;de-assert drive's reset pin
	djnz	r0, *
	djnz	r0, *
	djnz	r0, *
	ret



ide_init:
ideiwait:
	mov	dptr, #ide_head
	mov	a, #10100000b
	movx	@dptr, a		;select the master device
	mov	dptr, #ide_status
	movx	a, @dptr
	  push	acc
	  mov	a, #'.'			;should slow down the printing of dots
	  lcall	cout
	  acall	wait
	  pop	acc
	jnb	acc.6, ideiwait         ;wait for RDY bit to be set
	jb      acc.7, ideiwait         ;wait for BSY bit to be clear
	ret



ide_busy:
	mov	dptr, #ide_status
	movx	a, @dptr
	  push	acc
	  ;mov	a, #'.'
	  ;lcall	cout
	  acall	wait
	  pop	acc
	jb	acc.7, ide_busy		;wait for BSY to be clear
	ret


ide_drq:
	mov	dptr, #ide_status
	movx	a, @dptr
	  push	acc
	  ;mov	a, #'_'
	  ;lcall	cout
	  acall	wait
	  pop	acc
	jb	acc.7, ide_drq		;wait for BSY to be clear
	jnb     acc.3, ide_drq          ;wait for DRQ to be set
	ret



print_sector_buffer:
	push	acc
	push	dpl
	push	dph
	mov	a, r0
	push	acc
	mov	a, r1
	push	acc
	mov	dptr, #mesg_sector_buffer
	lcall	pstr

	mov	r0, #32
	mov	dptr, #sector_buffer
pb1:
	mov	r1, #16
pb2:
	movx	a, @dptr
	inc	dptr
	lcall	phex
	acall	space
	djnz	r1, pb2
	clr	c
	mov	a, dpl
	subb	a, #16
	mov	dpl, a
	mov	a, dph
	subb	a, #0
	mov	dph, a

	mov	r1, #16
pb3:
	movx	a, @dptr
	inc	dptr
	anl	a, #0x7F
	add	a, #224
	jc	pb4
	mov	a, #' ' - 32
pb4:	add	a, #32
	lcall	cout
	djnz	r1, pb3
	lcall	newline
	djnz	r0, pb1
	lcall	newline
	pop	acc
	mov	r1, a
	pop	acc
	mov	r0, a
	pop	dph
	pop	dpl
	pop	acc
	ret





grab_data:
	clr	a
	mov	dptr, #0xFF31
	movx	@dptr, a	;clear the address counter
	mov	dptr, #0xFF30

	movx	a, @dptr	;transfer bytes 0 to 31
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 32 to 63
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 64 to 95
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 96 to 127
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 128 to 159
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 160 to 191
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 192 to 223
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 224 to 255
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 256 to 287
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 288 to 319
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 320 to 351
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 352 to 383
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 384 to 415
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 416 to 447
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 448 to 479
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr

	movx	a, @dptr	;transfer bytes 480 to 511
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	movx	a, @dptr
	ret













mesg_read_mbr:
	.db	"Reading Master Boot Record",13,10,0
mesg_bad_mbr:
	.db	"MBR Signature Not Found",13,10,0
msg_unknown_partion_type:
	.db	"Unknown Partition Type: ",0
mesg_partition_at:
	.db	"Found FAT32 Partition at LBA = ",0

mesg_read_vol_id:
	.db	"Reading FAT32 Volume ID",13,10,0
mesg_bad_vol_id:
	.db	"Bad FAT32 Volume ID",13,10,0
mesg_first_data_sec:
	.db	"First Data Sector at LBA = ",0

mesg_playing_file:
	.db	"Playing file: ",0

mesg_vol_id_ok:
	.db	"Volume ID looks ok",13,10,0
mesg_sec_per_cluster:
	.db	"Sectors per cluster: ",0
mesg_root_dir_at_cluster:
	.db	"Root directory starts at cluster # ",0
mesg_sectors_for_fats:
	.db	"Sectors used for FAT tables: ",0
mesg_reserved_sectors:
	.db	"Reserved Sectors: ",0
mesg_attrib:
	.db	"  Attrib=",0
mesg_cluster:
	.db	"  First_Cluster=",0
mesg_size:
	.db	"  Size=",0
mesg_welcome:
	.db	13,10,13,10,13,10
	.db	"MP3 Player, Version 0.1.1, Sept 26, 2000",13,10
	.db	"Copyright (C) 2000, PJRC.COM, LLC",10,13,10,13
	.db	"Type 'QUIT' to return to the monitor",13,10,13,10,0
mesg_begin:
	.db	13,10,"MP3 Player, Begin Playback",13,10,0
mesg_xilinx_cfg:
	.db	"Configuring Xilinx XCS10XL FPGA Chip: ",0
mesg_ok:
	.db	"Ok",13,10,0
mesg_error:
	.db	"Error!",13,10,0
mesg_reset_ide:
	.db	"Reseting IDE Devices",13,10,0
mesg_sta013_cfg:
	.db	"Configuring STA013 MP3 Decoder Chip: ",0
mesg_ide_init:
	.db	"Waiting for Hard Drive to be ready",13,10,0

mesg_sector_buffer:
	.db	13,10,"Current Sector Buffer Contents:",13,10,0

mesg_play:
	.db	"Play",13,10,0
mesg_pause:
	.db	"Pause",13,10,0
mesg_next:
	.db	"Next File",13,10,0
mesg_prev:
	.db	"Previous File",13,10,0
mesg_rand:
	.db	"Random",13,10,0
mesg_vol_up:
	.db	"Vol Up",13,10,0
mesg_vol_down:
	.db	"Vol Down",13,10,0


str_quit:
	.db	4, "QUIT"
str_play:
	.db	4, "PLAY"
str_next:
	.db	4, "NEXT"
str_previous:
	.db	8, "PREVIOUS"







.org    location+0xF00
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     253,0,0,0               ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "Auto-Start",0
.org    location+0xF00+64       ;executable code begins here

	ljmp	begin



