; MP3 Player, Test DRAM, http://www.pjrc.com/tech/mp3
; Copyright (c) 2000, PJRC.COM, LLC

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

; As a specific exception to the GPL, the executable object code built
; from this source code may be combined with hardware configuration data
; files.  A hardware configuration data file is a set of data that is
; transmitted to an intergrated circuit that is not a general purpose
; microprocessor or microcontroller, in order to establish its normal
; operation.  The process of combining the executable ojbect code built
; from the GPL licensed source code with the hardware configuration data
; shall be considered an aggregation of another work not based on the
; Program.  While the GPL does not restrict use of the program, any
; use restriction associated with the hardware configuration data (for
; example, that it only be used with particular hardware) shall apply
; to the combined file which includes a copy of the hardware configuration
; data.

; Contact: paul@pjrc.com


.equ    location, 0x3000        ;where this program will exist


.equ    cout, 0x0030            ;Send Acc to serial port
.equ    cin, 0x0032             ;Get Acc from serial port
.equ    phex, 0x0034            ;Print Hex value of Acc
.equ	phex1, 0x002E
.equ    phex16, 0x0036          ;Print Hex value of DPTR
.equ    pstr, 0x0038            ;Print string pointed to by DPTR,
.equ    upper, 0x0040           ;Convert Acc to uppercase
.equ    pint8u, 0x004D          ;print Acc at an integer, 0 to 255
.equ    pint8, 0x0050           ;print Acc at an integer, -128 to 127
.equ    pint16u, 0x0053         ;print DPTR as an integer, 0 to 65535
.equ    newline, 0x0048         ;print CR/LF (13 and 10)


.equ	call_bank1, 0x0FE0
.equ	alt_xdownload, 0xA049



;addresses for accessing the DRAM controller
.equ	dram_addr_reg,	0xFF02		;4 bytes
.equ	dram_data_reg,	0xFF06		;2 bytes
.equ	dram_rd_cmd,	0xFF20
.equ	dram_wr_cmd,	0xFF21
.equ    dram_cfg_reg,   0xFF30



.org    location
.db     0xA5,0xE5,0xE0,0xA5     ;signiture bytes
.db     254,'T',0,0             ;id
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;reserved
.db     0,0,0,0                 ;user defined
.db     255,255,255,255         ;length and checksum (255=unused)
.db     "Test DRAM",0
.org    location+64             ;executable code begins here




begin:
	mov	p2, #0

	mov	dptr, #mesg_test
	lcall	pstr

	;ajmp	do_test

	mov	dptr, #mesg_xilinx_cfg
	lcall	pstr
	mov	dptr, #alt_xdownload
	lcall	call_bank1
	jc	error
	mov	dptr, #mesg_ok
	lcall	pstr
	ajmp	do_test



error:
	mov	dptr, #mesg_error
	lcall	pstr
	ajmp	quit



do_test:

	mov	r0, #200
	djnz	r0, *

	mov	r5, #0
	mov	r4, #0
	mov	r3, #0
	mov	r2, #3
	acall	set_addr
	mov	r3, #0xA7
	mov	r2, #0x41
	acall	set_data
	acall	write
	acall	print_shmem

	mov	r5, #0
	mov	r4, #5
	mov	r3, #1
	mov	r2, #3
	acall	set_addr
	mov	r3, #0x7A
	mov	r2, #0x56
	acall	set_data
	acall	write
	acall	print_shmem

	mov	r5, #0
	mov	r4, #0
	mov	r3, #15
	mov	r2, #9
	acall	set_addr
	mov	r3, #0x85
	mov	r2, #0xA9
	acall	set_data
	acall	write
	acall	print_shmem

	mov	r5, #0
	mov	r4, #0xaa
	mov	r3, #0x55
	mov	r2, #0xaa
	acall	set_addr
	mov	r3, #0xB9
	mov	r2, #0x91
	acall	set_data
	acall	write
	acall	print_shmem



	mov	r3, #0
	mov	r2, #0
	acall	set_data
	mov	r5, #0
	mov	r4, #0
	mov	r3, #0
	mov	r2, #0
	acall	set_addr
	lcall	newline


	mov	r5, #0
	mov	r4, #0
	mov	r3, #0
	mov	r2, #3
	acall	set_addr
	acall	read
	acall	print_shmem
	acall	get_data
	cjne	r3, #0xA7, fail
	cjne	r2, #0x41, fail

	mov	r5, #0
	mov	r4, #5
	mov	r3, #1
	mov	r2, #3
	acall	set_addr
	acall	read
	acall	print_shmem
	acall	get_data
	cjne	r3, #0x7A, fail
	cjne	r2, #0x56, fail

	mov	r5, #0
	mov	r4, #0
	mov	r3, #15
	mov	r2, #9
	acall	set_addr
	acall	read
	acall	print_shmem
	acall	get_data
	cjne	r3, #0x85, fail
	cjne	r2, #0xA9, fail

	mov	r5, #0
	mov	r4, #0xaa
	mov	r3, #0x55
	mov	r2, #0xaa
	acall	set_addr
	acall	read
	acall	print_shmem
	acall	get_data
	cjne	r3, #0xB9, fail
	cjne	r2, #0x91, fail

pass:
	mov	dptr, #mesg_pass
	lcall	pstr
	ret


fail:
	mov	dptr, #mesg_fail
	lcall	pstr
	ret


mesg_pass:
	.db	13,10,"DRAM test PASSED :)\n",13,10,0

mesg_fail:
	.db	13,10,"DRAM test FAILURE :(\n",13,10,0




write:
	mov	dptr, #dram_wr_cmd
	clr	a
	movx	@dptr, a
	ret

read:
	mov	dptr, #dram_rd_cmd
	clr	a
	movx	@dptr, a
	ret




set_addr:
	mov	dptr, #dram_addr_reg
	mov	a, r2
	movx	@dptr, a
	inc	dptr
	mov	a, r3
	movx	@dptr, a
	inc	dptr
	mov	a, r4
	movx	@dptr, a
	inc	dptr
	mov	a, r5
	movx	@dptr, a
	ret


get_data:
	mov	dptr, #dram_data_reg
	movx	a, @dptr
	mov	r2, a
	inc	dptr
	movx	a, @dptr
	mov	r3, a
	ret

set_data:
	mov	dptr, #dram_data_reg
	mov	a, r2
	movx	@dptr, a
	inc	dptr
	mov	a, r3
	movx	@dptr, a
	ret



print_shmem:
	acall	get_data
	mov	a, r3
	lcall	phex
	mov	a, r2
	lcall	phex

	acall	space

	mov	dptr, #dram_addr_reg
	movx	a, @dptr
	mov	r2, a
	inc	dptr
	movx	a, @dptr
	mov	r3, a
	inc	dptr
	movx	a, @dptr
	mov	r4, a
	inc	dptr
	movx	a, @dptr
	mov	r5, a

	mov	r0, #2
	acall	phex32_at_r0
	lcall	newline
	ret











wait:
	jb	ri, quit
	ret

quit:
	pop	acc
	pop	acc
	lcall	newline
	lcall	phex
	lcall	newline
	ret


space:
	mov	a, #' '
	ljmp	cout


	;print a 32 bit number stored @r0
phex32_at_r0:
	inc	r0
	inc	r0
	inc	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	dec	r0
	mov	a, @r0
	lcall	phex
	ret


mesg_test:
	.db	"DRAM Test",13,10,0
mesg_xilinx_cfg:
	.db	"Configuring Xilinx XCS10XL FPGA Chip: ",0
mesg_ok:
	.db	"Ok",13,10,0
mesg_error:
	.db	"Error!",13,10,0




